## rhash 1.2.8

=== Makefile ===
# Sample usage:
# compile with debug info: make CFLAGS=-g
# compile for pentiumpro: make CFLAGS="-O2 -DNDEBUG -march=i586 -mcpu=pentiumpro -fomit-frame-pointer"
# create rpm with statically linked program: make rpm ADDLDFLAGS="-static -s -Wl,--gc-sections"
CC      = gcc
VERSION = 1.2.8
PREFIX  = /usr/local
# using OPTFLAGS/OPTLDFLAGS for compatibilty with old scripts using this makefile
OPTFLAGS = -O2 -DNDEBUG -fomit-frame-pointer -ffunction-sections -fdata-sections
OPTLDFLAGS =
CFLAGS = $(OPTFLAGS)
LDFLAGS = $(OPTLDFLAGS)
ADDCFLAGS =
ADDLDFLAGS =
ALLCFLAGS = -pipe $(CFLAGS) $(ADDCFLAGS) \
  -Wall -W -Wstrict-prototypes -Wnested-externs -Winline -Wpointer-arith \
  -Wbad-function-cast -Wmissing-prototypes -Wmissing-declarations
LDLIBRHASH = -Llibrhash -lrhash
ALLLDFLAGS = $(LDLIBRHASH) $(LDFLAGS) $(ADDLDFLAGS)
HEADERS = calc_sums.h hash_print.h common_func.h hash_update.h file_mask.h file_set.h find_file.h hash_check.h output.h parse_cmdline.h rhash_main.h win_utils.h version.h
SOURCES = calc_sums.c hash_print.c common_func.c hash_update.c file_mask.c file_set.c find_file.c hash_check.c output.c parse_cmdline.c rhash_main.c win_utils.c
OBJECTS = calc_sums.o hash_print.o common_func.o hash_update.o file_mask.o file_set.o find_file.o hash_check.o output.o parse_cmdline.o rhash_main.o win_utils.o
OUTDIR   =
PROGNAME = rhash
TARGET   = $(OUTDIR)$(PROGNAME)
SYMLINKS = sfv-hash tiger-hash tth-hash whirlpool-hash has160-hash gost-hash ed2k-link magnet-link
SPECFILE = dist/rhash.spec
LIN_DIST_FILES = Makefile ChangeLog INSTALL COPYING README \
  $(SPECFILE) $(SPECFILE).in $(SOURCES) $(HEADERS) tests/test_rhash.sh \
  dist/rhash.1 dist/rhash.1.win.sed dist/rhash.1.html
WIN_DIST_FILES = dist/MD5.bat dist/magnet.bat dist/rhashrc.sample
WIN_SRC_FILES  = win32/dirent.h win32/stdint.h win32/unistd.h win32/platform-dependent.h \
  win32/vc-2010/rhash.vcxproj
LIBRHASH_FILES  = librhash/algorithms.c librhash/algorithms.h \
  librhash/byte_order.c librhash/byte_order.h librhash/timing.c librhash/timing.h \
  librhash/plug_openssl.c librhash/plug_openssl.h librhash/rhash.c librhash/rhash.h \
  librhash/aich.c librhash/aich.h librhash/crc32.c librhash/crc32.h \
  librhash/ed2k.c librhash/ed2k.h librhash/edonr.c librhash/edonr.h \
  librhash/gost.c librhash/gost.h librhash/has160.c librhash/has160.h \
  librhash/hex.c librhash/hex.h librhash/md4.c librhash/md4.h librhash/md5.c librhash/md5.h \
  librhash/ripemd-160.c librhash/ripemd-160.h librhash/sha1.c librhash/sha1.h \
  librhash/sha256.c librhash/sha256.h librhash/sha512.c librhash/sha512.h \
  librhash/snefru.c librhash/snefru.h librhash/tiger.c librhash/tiger.h \
  librhash/tiger_sbox.c librhash/tth.c librhash/tth.h librhash/whirlpool.c \
  librhash/whirlpool.h librhash/whirlpool_sbox.c librhash/test_hashes.c \
  librhash/test_hashes.h librhash/torrent.h librhash/torrent.c \
  librhash/util.c librhash/util.h librhash/config.h librhash/Makefile
I18N_FILES = po/rhash.pot po/ru.po
DIST_FILES     = $(LIN_DIST_FILES) $(LIBRHASH_FILES) $(WIN_DIST_FILES) $(WIN_SRC_FILES) $(I18N_FILES)
WIN_SUFFIX     = win32
ARCHIVE_BZIP   = rhash-$(VERSION)-src.tar.bz2
ARCHIVE_GZIP   = rhash-$(VERSION)-src.tar.gz
ARCHIVE_DEB_GZ = ../rhash_$(VERSION).orig.tar.gz
ARCHIVE_7Z     = rhash-$(VERSION)-src.tar.7z
ARCHIVE_ZIP    = rhash-$(VERSION)-$(WIN_SUFFIX).zip
WIN_ZIP_DIR    = RHash-$(VERSION)-$(WIN_SUFFIX)
DESTDIR = 
BINDIR  = $(PREFIX)/bin
MANDIR  = $(PREFIX)/share/man
LOCALEDIR = $(PREFIX)/share/locale
RPMTOP  = rpms
RPMDIRS = SOURCES SPECS BUILD SRPMS RPMS
LIBRHASH = librhash/librhash.a
# Set variables according to GNU coding standard
INSTALL = install
INSTALL_PROGRAM = $(INSTALL) -m 755
INSTALL_DATA    = $(INSTALL) -m 644

all: $(TARGET)
install: install-program install-symlinks
uninstall: uninstall-program uninstall-symlinks

# creating archives
dist: gzip
gzip: check $(ARCHIVE_GZIP)
bzip: check $(ARCHIVE_BZIP)
7z:   check $(ARCHIVE_7Z)
zip : $(ARCHIVE_ZIP)
win-dist : $(ARCHIVE_ZIP)

install-program: all
	$(INSTALL) -d $(DESTDIR)$(BINDIR) $(DESTDIR)$(MANDIR)/man1 $(DESTDIR)/etc
	$(INSTALL_PROGRAM) $(TARGET) $(DESTDIR)$(BINDIR)
	$(INSTALL_DATA) dist/rhash.1 $(DESTDIR)$(MANDIR)/man1/rhash.1
	sed -e 's/\x0D//g' dist/rhashrc.sample > rhashrc && $(INSTALL_DATA) rhashrc $(DESTDIR)/etc/rhashrc
	rm -f rhashrc

# dependencies should be properly set, otherwise 'make -j<n>' can run install targets in parallel
install-symlinks: install-program
	for f in $(SYMLINKS); do ln -s rhash $(DESTDIR)$(BINDIR)/$$f; done
	cd $(DESTDIR)$(MANDIR)/man1 && for f in $(SYMLINKS); do ln -s rhash.1* $$f.1; done

uninstall-program:
	rm -f $(DESTDIR)$(BINDIR)/$(PROGNAME)
	rm -f $(DESTDIR)$(MANDIR)/man1/rhash.1

uninstall-symlinks:
	for f in $(SYMLINKS); do rm -f $(DESTDIR)$(BINDIR)/$$f; done

install-lib-static:
	cd librhash && make install-lib-static

install-lib-shared:
	cd librhash && make install-lib-shared

lib-static: $(LIBRHASH)

lib-shared :
	cd librhash && make lib-shared

test-hashes:
	cd librhash && make test

test: $(TARGET) test-hashes
	chmod +x tests/test_$(PROGNAME).sh
	tests/test_$(PROGNAME).sh

version.h : Makefile
	echo "#define VERSION \"$(VERSION)\"" > version.h

check: version.h
# check version
	grep -q '\* === Version $(VERSION) ===' ChangeLog
	grep -q '^#define VERSION "$(VERSION)"' version.h
	[ -s dist/rhash.1.html ]

$(LIBRHASH): $(LIBRHASH_FILES)
	cd librhash && make lib-static

$(TARGET): $(OBJECTS) $(LIBRHASH)
	$(CC) $(OBJECTS) -o $(TARGET) $(ALLLDFLAGS)

# NOTE: dependences were generated by 'gcc -Ilibrhash -MM *.c'
# we are using plain old makefile style to support BSD make
calc_sums.o: calc_sums.c common_func.h librhash/util.h librhash/hex.h \
 librhash/rhash.h librhash/timing.h parse_cmdline.h rhash_main.h \
 file_set.h calc_sums.h hash_check.h hash_print.h output.h win_utils.h \
 version.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

common_func.o: common_func.c common_func.h librhash/util.h librhash/hex.h \
 win_utils.h parse_cmdline.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

hash_print.o: hash_print.c common_func.h librhash/util.h librhash/hex.h \
 librhash/byte_order.h calc_sums.h librhash/rhash.h hash_check.h \
 parse_cmdline.h hash_print.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

hash_update.o: hash_update.c common_func.h librhash/util.h \
 librhash/timing.h win_utils.h parse_cmdline.h output.h rhash_main.h \
 file_set.h calc_sums.h librhash/rhash.h hash_check.h file_mask.h \
 hash_update.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

file_mask.o: file_mask.c common_func.h librhash/util.h file_mask.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

file_set.o: file_set.c librhash/hex.h librhash/crc32.h common_func.h \
 librhash/util.h hash_print.h parse_cmdline.h rhash_main.h output.h \
 file_set.h calc_sums.h librhash/rhash.h hash_check.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

find_file.o: find_file.c common_func.h librhash/util.h win_utils.h \
 find_file.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

hash_check.o: hash_check.c librhash/hex.h librhash/byte_order.h \
 librhash/rhash.h output.h parse_cmdline.h hash_print.h hash_check.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

output.o: output.c common_func.h librhash/util.h librhash/rhash.h \
 calc_sums.h hash_check.h parse_cmdline.h rhash_main.h output.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

parse_cmdline.o: parse_cmdline.c common_func.h librhash/util.h \
 librhash/rhash.h librhash/plug_openssl.h win_utils.h file_mask.h \
 hash_print.h output.h rhash_main.h version.h parse_cmdline.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

rhash_main.o: rhash_main.c common_func.h librhash/util.h \
 librhash/timing.h win_utils.h find_file.h file_set.h calc_sums.h \
 librhash/rhash.h hash_check.h hash_update.h file_mask.h hash_print.h \
 parse_cmdline.h output.h version.h rhash_main.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

win_utils.o: win_utils.c common_func.h librhash/util.h parse_cmdline.h \
 rhash_main.h win_utils.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

dist/rhash.1.win.html: dist/rhash.1 dist/rhash.1.win.sed
	sed -f dist/rhash.1.win.sed dist/rhash.1 | rman -fHTML -roff | \
	sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > dist/rhash.1.win.html
#	verify the result
	grep -q "utf8" dist/rhash.1.win.html
	grep -q "APPDATA" dist/rhash.1.win.html

dist/rhash.1.html: dist/rhash.1
	-which rman &>/dev/null && (rman -fHTML -roff dist/rhash.1 | sed -e '/<BODY/s/\(bgcolor=\)"[^"]*"/\1"white"/i' > $@)

dist/rhash.1.txt: dist/rhash.1
	-which groff &>/dev/null && (groff -t -e -mandoc -Tascii dist/rhash.1 | sed -e 's/.\[[0-9]*m//g' > $@)

cpp-doc:
	cppdoc_cmd -title=RHash -company=Animegorodok -classdir=classdoc -module="cppdoc-standard" -overwrite -extensions="c,h" -languages="c=cpp,h=cpp" -generate-deprecations-list=false $(SOURCES) $(HEADERS) ./Documentation/CppDoc/index.html

permissions:
	chmod -x $(DIST_FILES)
	chmod +x tests/test_$(PROGNAME).sh

$(ARCHIVE_GZIP): $(DIST_FILES)
	make permissions
	rm -rf $(PROGNAME)-$(VERSION)
	mkdir $(PROGNAME)-$(VERSION)
	cp -rl --parents $(DIST_FILES) $(PROGNAME)-$(VERSION)/
	make -C bindings distclean
	find bindings/ -type f -regex '.*\(\.\([hct]\|java\|PL\|pm\|py\|rb\|txt\|xs\)\|Makefile\|MANIFEST\|typemap\)' -exec cp -l --parents '{}' $(PROGNAME)-$(VERSION)/ \;
	tar czf $(ARCHIVE_GZIP) $(PROGNAME)-$(VERSION)/
	rm -rf $(PROGNAME)-$(VERSION)

$(ARCHIVE_BZIP): $(DIST_FILES)
	make permissions
	rm -rf $(PROGNAME)-$(VERSION)
	mkdir $(PROGNAME)-$(VERSION)
	cp -rl --parents $(DIST_FILES) $(PROGNAME)-$(VERSION)/
	tar cjf $(ARCHIVE_BZIP) $(PROGNAME)-$(VERSION)/
	rm -rf $(PROGNAME)-$(VERSION)

$(ARCHIVE_7Z): $(DIST_FILES)
	make permissions
	rm -rf $(PROGNAME)-$(VERSION)
	mkdir $(PROGNAME)-$(VERSION)
	cp -rl --parents $(DIST_FILES) $(PROGNAME)-$(VERSION)/
	tar cf - $(PROGNAME)-$(VERSION)/ | 7zr a -si $(ARCHIVE_7Z)
	rm -rf $(PROGNAME)-$(VERSION)

$(ARCHIVE_ZIP): $(WIN_DIST_FILES) dist/rhash.1.win.html
	[ -s dist/rhash.1.win.html -a -x $(TARGET) ]
	-rm -rf $(WIN_ZIP_DIR)
	mkdir $(WIN_ZIP_DIR)
	cp $(TARGET).exe ChangeLog $(WIN_DIST_FILES) $(WIN_ZIP_DIR)/
	cp dist/rhash.1.win.html $(WIN_ZIP_DIR)/rhash-doc.html
	-[ -f $(OUTDIR)libeay32.dll ] && cp $(OUTDIR)libeay32.dll $(WIN_ZIP_DIR)/
	zip -9r $(ARCHIVE_ZIP) $(WIN_ZIP_DIR)
	rm -rf $(WIN_ZIP_DIR)

$(ARCHIVE_DEB_GZ) : $(DIST_FILES)
	make $(ARCHIVE_GZIP)
	mv -f $(ARCHIVE_GZIP) $(ARCHIVE_DEB_GZ)

# rpm packaging
$(SPECFILE): $(SPECFILE).in Makefile
	sed -e 's/@VERSION@/$(VERSION)/' $(SPECFILE).in > $(SPECFILE)

rpm: gzip
	-for i in $(RPMDIRS); do mkdir -p $(RPMTOP)/$$i; done
	cp -f $(ARCHIVE_GZIP) $(RPMTOP)/SOURCES
	rpmbuild -ba --clean --define "_topdir `pwd`/$(RPMTOP)" $(SPECFILE)
	mv -f `find $(RPMTOP) -name "*rhash*-$(VERSION)*.rpm"` .
	rm -rf $(RPMTOP)

distclean: clean

clean:
	cd librhash && make clean
	rm -f *.o $(TARGET)
	rm -f po/*.gmo
	rm -f po/*.po~

update-po:
	xgettext *.c -k_ -cTRANSLATORS -o po/rhash.pot \
		--msgid-bugs-address='rhash.admin@gmail.com' --package-name='RHash'
	for f in po/*.po; do \
		msgmerge -U $$f po/rhash.pot; \
	done

compile-gmo:
	for f in po/*.po; do \
		g=`basename $$f .po`; \
		msgfmt $$f -o po/$$g.gmo; \
	done

install-gmo: compile-gmo
	for f in po/*.gmo; do \
		l=`basename $$f .gmo`; \
		$(INSTALL) -d $(DESTDIR)$(LOCALEDIR)/$$l/LC_MESSAGES; \
		$(INSTALL_DATA) -T $$f $(DESTDIR)$(LOCALEDIR)/$$l/LC_MESSAGES/rhash.mo; \
	done

=== bindings/Makefile ===
MAKE = make
RUBY = ruby
PERL = /usr/bin/perl
DESTDIR =
PREFIX = /usr/local
PERL_OPTIMIZE = -O2 -g -Wall

all: configure build test
configure: configure-ruby configure-perl
build: build-java build-perl build-ruby
test: test-java test-perl test-ruby
install: install-ruby install-perl
clean: distclean

configure-perl:
	cd perl && perl Makefile.PL INSTALLDIRS=vendor

configure-ruby:
	$(RUBY) -C ruby extconf.rb

build-java:
	$(MAKE) -C java/ jar jar-symlink jni javadoc

build-perl:
	$(MAKE) -C perl OPTIMIZE="$(PERL_OPTIMIZE)"

build-ruby:
	$(MAKE) -C ruby

test-java:
	$(MAKE) -C java test

test-perl:
	$(MAKE) -C perl test

test-ruby:
	$(RUBY) -C ruby test_rhash.rb

install-ruby:
	$(MAKE) -C ruby install DESTDIR=$(DESTDIR) sitedir=$(DESTDIR)/usr/lib/ruby

install-perl:
	$(MAKE) -C perl install DESTDIR=$(DESTDIR)
#	$(MAKE) -C perl install DESTDIR=$(DESTDIR) PREFIX=$(PREFIX) SITEPREFIX=$(PREFIX)

distclean:
	$(MAKE) -C java distclean
	[ ! -f ruby/Makefile ] || $(MAKE) -C ruby distclean
	[ ! -f perl/Makefile ] || $(MAKE) -C perl distclean

=== librhash/Makefile ===
# Makefile for LibRHash
CC      = gcc
AR      = ar
#NOTE: NDEBUG turns off asserts
OPTFLAGS   = -O2 -DNDEBUG -fomit-frame-pointer -ffunction-sections -fdata-sections
OPTLDFLAGS =
CFLAGS     = $(OPTFLAGS)
LDFLAGS    = $(OPTLDFLAGS)
ADDCFLAGS  =
ADDLDFLAGS =
DEFS    = -DIN_RHASH
ALLCFLAGS  = -pipe $(DEFS) $(ADDCFLAGS) $(CFLAGS) \
  -Wall -W -Wstrict-prototypes -Wnested-externs -Winline -Wpointer-arith \
  -Wbad-function-cast -Wmissing-prototypes -Wmissing-declarations
LDRHASH    = -L. -lrhash
LDLIBFLAGS = $(LDFLAGS) $(ADDLDFLAGS)
ALLLDFLAGS = $(LDRHASH) $(LDFLAGS) $(ADDLDFLAGS)
HEADERS = algorithms.h aich.h timing.h byte_order.h plug_openssl.h rhash.h crc32.h util.h ed2k.h edonr.h hex.h md4.h md5.h sha1.h sha256.h sha512.h ripemd-160.h gost.h has160.h snefru.h tiger.h              tth.h torrent.h whirlpool.h
SOURCES = algorithms.c aich.c timing.c byte_order.c plug_openssl.c rhash.c crc32.c util.c ed2k.c edonr.c hex.c md4.c md5.c sha1.c sha256.c sha512.c ripemd-160.c gost.c has160.c snefru.c tiger.c tiger_sbox.c tth.c torrent.c whirlpool.c whirlpool_sbox.c
OBJECTS = algorithms.o aich.o timing.o byte_order.o plug_openssl.o rhash.o crc32.o util.o ed2k.o edonr.o hex.o md4.o md5.o sha1.o sha256.o sha512.o ripemd-160.o gost.o has160.o snefru.o tiger.o tiger_sbox.o tth.o torrent.o whirlpool.o whirlpool_sbox.o
HEADERS_LIB = rhash.h timing.h
# installation directories and names
DESTDIR =
PREFIX  = /usr/local
INCDIR  = $(PREFIX)/include/rhash
LIBDIR  = $(PREFIX)/lib
LIBRARY = librhash.a
SONAME  = librhash.so.0
SOLINK  = librhash.so
TEST_TARGET = test_hashes
TEST_SHARED = test_shared
# Set variables according to GNU coding standard
INSTALL = install
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_SHARED  = $(INSTALL) -m 644

all: $(LIBRARY)
lib-static: $(LIBRARY)
lib-shared: $(SONAME)
dist-clean: clean

install-lib-static: $(LIBRARY)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCDIR)
	$(INSTALL_DATA) $(LIBRARY) $(DESTDIR)$(LIBDIR)/
	$(INSTALL_DATA) $(HEADERS_LIB) $(DESTDIR)$(INCDIR)/
	ln -s $(SONAME) $(DESTDIR)$(LIBDIR)/$(SOLINK)

install-lib-shared: $(SONAME)
	$(INSTALL) -d $(DESTDIR)$(LIBDIR)
	$(INSTALL_SHARED) $(SONAME) $(DESTDIR)$(LIBDIR)/

uninstall-lib-static:
	rm -f $(DESTDIR)$(LIBDIR)/$(LIBRARY) $(DESTDIR)$(INCDIR)/*.h
	rm -f $(DESTDIR)$(LIBDIR)/$(SOLINK)
	-rmdir $(DESTDIR)$(INCDIR)

uninstall-lib-shared:
	rm -f $(DESTDIR)$(LIBDIR)/$(SONAME)

install-all-headers:
	$(INSTALL_DATA) $(HEADERS) $(DESTDIR)$(INCDIR)/

# not using GNU make extensions for compatibility with Unix/*BSD make
#%.o: %.c
#	$(CC) -c $(ALLCFLAGS) $< -o $@

# NOTE: dependences were generated by 'gcc -MM -DIN_RHASH *.c'
# we are using plain old makefile style to support BSD make
aich.o: aich.c byte_order.h config.h algorithms.h rhash.h aich.h sha1.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

algorithms.o: algorithms.c byte_order.h config.h rhash.h algorithms.h \
 aich.h sha1.h crc32.h ed2k.h md4.h edonr.h gost.h has160.h md5.h \
 ripemd-160.h snefru.h sha256.h sha512.h tiger.h torrent.h tth.h \
 whirlpool.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

byte_order.o: byte_order.c byte_order.h config.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

crc32.o: crc32.c byte_order.h config.h crc32.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

ed2k.o: ed2k.c ed2k.h md4.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

edonr.o: edonr.c byte_order.h config.h edonr.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

gost.o: gost.c byte_order.h config.h gost.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

has160.o: has160.c byte_order.h config.h has160.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

hex.o: hex.c hex.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

md4.o: md4.c byte_order.h config.h md4.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

md5.o: md5.c byte_order.h config.h md5.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

plug_openssl.o: plug_openssl.c algorithms.h rhash.h byte_order.h config.h \
 plug_openssl.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

rhash.o: rhash.c byte_order.h config.h algorithms.h rhash.h torrent.h \
 sha1.h plug_openssl.h util.h hex.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

ripemd-160.o: ripemd-160.c byte_order.h config.h ripemd-160.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

sha1.o: sha1.c byte_order.h config.h sha1.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

sha256.o: sha256.c byte_order.h config.h sha256.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

sha512.o: sha512.c byte_order.h config.h sha512.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

snefru.o: snefru.c byte_order.h config.h snefru.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

test_hashes.o: test_hashes.c byte_order.h config.h timing.h rhash.h \
 test_hashes.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

tiger.o: tiger.c byte_order.h config.h tiger.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

tiger_sbox.o: tiger_sbox.c byte_order.h config.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

timing.o: timing.c byte_order.h config.h rhash.h timing.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

torrent.o: torrent.c byte_order.h config.h algorithms.h rhash.h torrent.h \
 sha1.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

tth.o: tth.c byte_order.h config.h tth.h tiger.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

util.o: util.c util.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

whirlpool.o: whirlpool.c byte_order.h config.h whirlpool.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

whirlpool_sbox.o: whirlpool_sbox.c byte_order.h config.h
	$(CC) -c $(ALLCFLAGS) $< -o $@

# MINGW dll target
DLLNAME = librhash.dll

dll: $(DLLNAME)
$(DLLNAME): $(SOURCES)
#	rm -f $@
	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' rhash.h timing.h > exports.sym
	$(CC) -DRHASH_EXPORTS $(ALLCFLAGS) -shared -Wl,--version-script,exports.sym,-soname,$@ $(LDLIBFLAGS) $(SOURCES) -o $@

test-dll: $(DLLNAME) test_hashes.o
	$(CC) test_hashes.o $(DLLNAME) -o $(TEST_SHARED) && ./$(TEST_SHARED)

# shared and static libraries
$(SONAME): $(SOURCES)
#	rm -f $@
	sed -n '1s/.*/{ global:/p; s/^RHASH_API.* \([a-z0-9_]\+\)(.*/  \1;/p; $$s/.*/local: *; };/p' rhash.h timing.h > exports.sym
	$(CC) -fpic $(ALLCFLAGS) -shared -Wl,--version-script,exports.sym,-soname,$(SONAME) $(LDLIBFLAGS) $(SOURCES) -o $@
# use 'nm -Cg --defined-only $@' to view exported symbols

$(LIBRARY): $(OBJECTS)
	$(AR) cqs $@ $(OBJECTS)
#	$(AR) cr $(LIBRARY) $(OBJECTS) && runlib $(LIBRARY)

$(TEST_TARGET): $(LIBRARY) test_hashes.o
	$(CC) test_hashes.o $(ALLLDFLAGS) -o $@

#$(TEST_SHARED): $(DLLNAME) test_hashes.o
#	$(CC) test_hashes.o $(DLLNAME) -o $@

test-shared: $(SONAME) test_hashes.o
	$(CC) test_hashes.o $(SONAME) $(LDLIBFLAGS) -o $(TEST_SHARED)
	LD_LIBRARY_PATH=. ./$(TEST_SHARED)

test: $(TEST_TARGET)
	./$(TEST_TARGET)
	if [ -f $(SONAME) ]; then make test-shared; fi
#	if [ -f $(DLLNAME) ]; then make test-dll; fi

clean:
	rm -f *.o $(LIBRARY) $(TEST_TARGET) $(TEST_SHARED) $(SONAME) exports.sym

=== bindings/java/Makefile ===
#!/usr/bin/make -f

# This file is a part of Java Bindings for Librhash
# Copyright (c) 2011, Sergey Basalaev <sbasalaev@gmail.com>
# Librhash is (c) 2011, Alexey S Kravchenko <rhash.admin@gmail.com>
# 
# Permission is hereby granted, free of charge,  to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction,  including without limitation the rights
# to  use,  copy,  modify,  merge, publish, distribute, sublicense, and/or sell
# copies  of  the Software,  and  to permit  persons  to whom  the Software  is
# furnished to do so.
# 
# This library  is distributed  in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. Use it at your own risk!


MAKE = make
JAVA = java
JAVAC = javac
JAVADOC = javadoc
JAVAH = javah
JAR = jar

VERSION = $(shell sed -e 's/.*"\(.*\)".*/\1/' ../../version.h)

JAVASRC_DIR = src
CSRC_DIR    = native
DEST_DIR    = dist
CLASSES_DIR = classes
JAVADOC_DIR = javadoc
TEST_DIR    = test

JAVADOC_API_URL = http://download.oracle.com/javase/6/docs/api/

JARFILE = $(DEST_DIR)/rhash-$(VERSION).jar

all: jar jni test

jar: compile-classes
	mkdir -p $(DEST_DIR)
	$(JAR) cf $(JARFILE) -C $(CLASSES_DIR) org/

jar-symlink:
	ln -s rhash-$(VERSION).jar $(DEST_DIR)/rhash.jar

compile-classes:
	mkdir -p $(CLASSES_DIR)
	$(JAVAC) -d $(CLASSES_DIR) -sourcepath $(JAVASRC_DIR) `find ${JAVASRC_DIR} -name '*.java'`

update-header: compile-classes
	$(JAVAH) -o $(CSRC_DIR)/bindings.h -classpath $(CLASSES_DIR)  org.sf.rhash.Bindings

jni:
	$(MAKE) -C $(CSRC_DIR)
	mkdir -p $(DEST_DIR)
	cp $(CSRC_DIR)/*rhash-jni* $(DEST_DIR)

javadoc: clean-javadoc
	$(JAVADOC) -windowtitle 'RHash' \
	           -sourcepath src \
	           -subpackages org \
	           -d $(JAVADOC_DIR) \
	           -link $(JAVADOC_API_URL)

test: jar jni
	$(JAVAC) -classpath $(JARFILE) $(TEST_DIR)/Test.java
	$(JAVA) -classpath $(TEST_DIR):$(JARFILE) -Djava.library.path=$(DEST_DIR) Test

clean: clean-javadoc clean-jni clean-classes clean-test

clean-javadoc:
	rm -rf $(JAVADOC_DIR)

clean-classes:
	rm -rf $(CLASSES_DIR)

clean-jni:
	$(MAKE) -C $(CSRC_DIR) clean

clean-test:
	rm -f $(TEST_DIR)/*.class

distclean: clean
	rm -rf $(DEST_DIR)

.PHONY: jar jni javadoc clean clean-javadoc distclean

=== bindings/java/native/Makefile ===
#!/usr/bin/make -f

# This file is a part of Java Bindings for Librhash
# Copyright (c) 2011, Sergey Basalaev <sbasalaev@gmail.com>
# Librhash is (c) 2011, Alexey S Kravchenko <rhash.admin@gmail.com>
# 
# Permission is hereby granted, free of charge,  to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction,  including without limitation the rights
# to  use,  copy,  modify,  merge, publish, distribute, sublicense, and/or sell
# copies  of  the Software,  and  to permit  persons  to whom  the Software  is
# furnished to do so.
# 
# This library  is distributed  in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. Use it at your own risk!


CC = gcc
CFLAGS = -g -O2
LIBRHASH_INC =
LIBRHASH_LD  =
LDFLAGS = -lrhash $(LIBRHASH_LD)
ALLCFLAGS = $(CFLAGS) $(LIBRHASH_INC) -fPIC

#Platform dependent
JNI_INCLUDES = /usr/lib/jvm/default-java/include
LIB_PREFIX = lib
LIB_SUFFIX = .so

OBJECTS = bindings.o digest.o
LIBRARY = $(LIB_PREFIX)rhash-jni$(LIB_SUFFIX)

all: $(LIBRARY)

bindings.o: bindings.c bindings.h
	$(CC) $(ALLCFLAGS) -I$(JNI_INCLUDES) -c $< -o $@

digest.o: digest.c digest.h
	$(CC) $(ALLCFLAGS) -c $< -o $@

$(LIBRARY): $(OBJECTS)
	$(CC) $(LDFLAGS) -shared -o $@ $(OBJECTS)

clean:
	rm -f *.o $(LIBRARY)

=== debian/changelog ===
rhash (1.2.8-3) unstable; urgency=low

  * fixed loading of the RHash python module (Closes: 652302)
  * fixed librhash-java compilation on Ubuntu (Closes: 654180)
  * updated debian/copyright

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Wed, 18 Jan 2012 22:51:54 +0700

rhash (1.2.8-2) unstable; urgency=low

  * Compilation fix for several Debian architectures
  - fixed librhash-java compilation with gcj (Closes: 644599)
  - control: added python-rhash dependency on librhash0

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 09 Oct 2011 13:57:47 +0700

rhash (1.2.8-1) unstable; urgency=low

  * New upstream release version 1.2.8
   - language bindings for Java, Perl, Python, Ruby
   - Russian translation
   - fixed recommended libssl1.0.0 dependency
   - patched broken re-compilation
   - fixed a mistype in perl documentation
   - control: updated Vcs-Git field
   - copyright: corrected Format field, added Upstream-Contact
   - copyright: updated Copyright field, mentioned another developer

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Wed, 14 Sep 2011 23:50:14 +0700

rhash (1.2.7-1) unstable; urgency=medium

  * New upstream release version 1.2.7
   - Fixes security issue (Closes: #632280)
   - changed author/mantainer name to the way I prefer s/Alexey S/Aleksey/
   - simplified desriptions of binary packages
   - wriiten rules in more now standard way, using CFLAGS/LDFLAGS
   - reworded README.Debian a bit
   - aplied patch from upstream to fix possible segfault
   - aplied patch from upstream to fix glibc runtime warning
   - aplied patch from upstream to repair -openssl option handling

 -- Aleksey Kravchenko <rhash.admin@gmail.com>  Sun, 14 Aug 2011 20:35:00 +0700

=== debian/control ===
Source: rhash
Section: utils
Priority: optional
Maintainer: Aleksey Kravchenko <rhash.admin@gmail.com>
Build-Depends: debhelper (>= 8), libssl-dev (>= 1.0.0), default-jdk, perl, python (>= 2.6.6-3~), ruby, ruby1.8-dev, chrpath
Build-Depends-Indep: default-jdk-doc
Standards-Version: 3.9.2
Homepage: http://rhash.sourceforge.net/
Vcs-Git: git://github.com/rhash/RHash.git
Vcs-Browser: https://github.com/rhash/RHash

Package: rhash
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl1.0.0 (>= 1.0.0)
Description: utility for computing hash sums and magnet links
 RHash is a console utility for calculation and verification of magnet links
 and a wide range of hash sums like CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Output in a predefined (SFV, BSD-like) or a user-defined format.
  * Can calculate Magnet links and EDonkey 2000 links.
  * Updating hash files (adding hash sums of files missing in the hash file).
  * Ability to process directories recursively.
  * Portability: the program works the same on Linux, *BSD or Windows.

Package: librhash0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libssl1.0.0 (>= 1.0.0)
Description: shared library for hash functions computing
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 Hash sums are used to ensure and verify integrity of large volumes of data
 for a long-term storing or transferring.
 .
 Features:
  * Small and easy to learn interface.
  * Hi-level and Low-level API.
  * Allows calculating of several hash functions simultaneously.
  * Portability: the library works on Linux, *BSD and Windows.

Package: librhash-dev
Architecture: any
Section: libdevel
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Description: header files of librhash and static library
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains LibRHash static library and header files.

Package: librhash0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: librhash0 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for librhash
 LibRHash is a professional, portable, thread-safe C library for computing 
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1/SHA2, AICH,
 ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains debug information for the librhash shared library.


Package: python-rhash
Section: python
Architecture: all
Depends: librhash0 (>= ${source:Version}), ${python:Depends}, ${misc:Depends}
X-Python-Version: >= 2.6
Description: Python interface for LibRHash hash sums calculation library
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains the files needed to use the RHash library
 in Python programs.

Package: librhash-java
Section: java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Java interface for LibRHash hash sums calculation library
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains the files needed to use the RHash library
 in Java programs.

Package: librhash-java-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: default-jdk-doc
Description: documentation for librhash Java bindings
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains documentation for Java interface of the RHash library.

Package: librhash-perl
Section: perl
Architecture: any
Depends: ${perl:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Perl interface for LibRHash hash sums calculation library
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains the files needed to use the RHash library
 in Perl programs.

Package: librhash-ruby
Section: ruby
Architecture: all
Depends: librhash-ruby1.8 (>= ${source:Version}), ${misc:Depends}
Description: Ruby interface for LibRHash hash sums calculation library
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This is dependency package which depends on Debian's default Ruby version. 

Package: librhash-ruby1.8
Section: ruby
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Ruby 1.8 interface for LibRHash hash sums calculation library
 LibRHash is a professional, portable, thread-safe C library for computing
 a wide variety of hash sums, such as CRC32, MD4, MD5, SHA1, SHA256, SHA512,
 AICH, ED2K, Tiger, DC++ TTH, BitTorrent BTIH, GOST R 34.11-94, RIPEMD-160,
 HAS-160, EDON-R, Whirlpool and Snefru.
 .
 This package contains the files needed to use the RHash library
 in Ruby programs.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules makefile that uses debhelper.
#
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
INSTALL_PROGRAM = install -p -m 755
CFLAGS = -Wall
LDFLAGS =
DESTDIR = $(CURDIR)/debian/tmp

# see Debian Policy Manual - source packages
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0 -DNDEBUG
else
	CFLAGS += -O2 -DNDEBUG -fomit-frame-pointer
endif
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

# by default compile RHash with openssl runtime linking
ifeq (,$(findstring nossl,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -DUSE_OPENSSL
ifneq (,$(findstring ssldynamic,$(DEB_BUILD_OPTIONS)))
	LDFLAGS += -lcrypto
else
	CFLAGS  += -DOPENSSL_RUNTIME -rdynamic
	LDFLAGS += -ldl
endif
endif

# using debhelper >= 8 to build the package
%:
	dh $@ --with python2

override_dh_auto_build:
	# Compile the package.
	$(MAKE) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" lib-shared all
	mkdir -p $(DESTDIR) && ln -fs $(CURDIR)/librhash $(DESTDIR)/rhash
	ln -fs $(CURDIR)/librhash/librhash.so.0 $(DESTDIR)/ && ln -fs librhash.so.0 $(DESTDIR)/librhash.so
	LIBRHASH_INC=-I$(DESTDIR) LIBRHASH_LD=-L$(DESTDIR) $(MAKE) -C bindings configure
	$(MAKE) -C bindings build LIBRHASH_INC=-I$(DESTDIR) LIBRHASH_LD=-L$(DESTDIR)
	chrpath -d bindings/perl/blib/arch/auto/Rhash/Rhash.so

override_dh_auto_test:
	$(MAKE) CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" test
	LD_LIBRARY_PATH=$(DESTDIR) $(MAKE) -C bindings test

override_dh_auto_install:
	# Install the program and its translation strings
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/rhash INSTALL_PROGRAM="$(INSTALL_PROGRAM)" install install-gmo
	# Install static library
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/librhash-dev install-lib-static
	# Install shared library
	$(MAKE) PREFIX=/usr DESTDIR=$(CURDIR)/debian/librhash0 install-lib-shared
	# Install language bindings
	$(MAKE) -C bindings install DESTDIR=$(DESTDIR) PREFIX=/usr sitedir=$(DESTDIR)/usr/lib/ruby

override_dh_strip:
	dh_strip -plibrhash0 --dbg-package=librhash0-dbg
	dh_strip

override_dh_auto_clean:
	$(MAKE) distclean
	$(MAKE) -C bindings distclean
